#include "libcell.h"

void register_session (_comm_header *comm, int debug)
{
_data_buffer *buff;
_encaps_header *head;
_data_buffer *receive_buffer;
int x;

dprint (DEBUG_TRACE,"--- Register_session.c entered\n");
	
head = malloc (ENCAPS_Header_Length);
if (head ==NULL)
	{
	printf ("Could not allocate memory for Register_session.\n");
	exit (-1);
	}

buff = malloc (DATA_Buffer_Length);
if (buff == NULL)
	{
	printf ("Could not allocate memory for transmit buffer.\n");
	exit (-1);
	}
	
receive_buffer = malloc (DATA_Buffer_Length);
if (receive_buffer ==NULL)
	{
	printf ("Could not allocate memory for Receive Buffer - Register_session.\n");
	exit (-1);
	}


memset (buff,0, DATA_Buffer_Length );
memset (head,0, ENCAPS_Header_Length );
memset (receive_buffer,0, DATA_Buffer_Length );

fill_header (comm, head, debug);


head->command = ENCAPS_Register_Session;
head->len = 4;
memcpy (buff->data, head, ENCAPS_Header_Length);
buff->data[ENCAPS_Header_Length] = 1; /* Protocol Version Number */

buff->overall_len = ENCAPS_Header_Length+4;

senddata (buff, comm, debug);

readdata (receive_buffer, comm, debug);
memset (head,0, ENCAPS_Header_Length);

memcpy (head, receive_buffer->data, ENCAPS_Header_Length);
comm->session_id = head->handle;

if (debug != DEBUG_NIL)
	{
	dprint (DEBUG_VALUES,"command = %02X\n",head->command);
	dprint (DEBUG_VALUES,"len = %d\n",head->len);
	dprint (DEBUG_VALUES,"handle = %ld\n",head->handle);
	dprint (DEBUG_VALUES,"status = %ld\n",head->status);
	dprint (DEBUG_VALUES,"context = ");
	for (x=0;x<8;x++)
		dprint (DEBUG_VALUES,"%02X ",head->context[x]);
	dprint (DEBUG_VALUES,"\nOptions = %ld\n",head->options);
	}
			
free (head);
free (buff);
free (receive_buffer);
dprint (DEBUG_TRACE, "register_session.c exited.\n");
return;
}


